/************************************************************************
 *
 *   File: common.h:
 *   
 *   Author: Mark Stephenson
 *   Date: Mon Aug  5 14:20:58 2002
 *
 *   Function: Contains common definitions and dispatch tables. 
 *
 ***********************************************************************/

#ifndef _COMMON_DEFS_H__
#define _COMMON_DEFS_H__

#include <sys/types.h>

typedef int32_t   int32;
typedef u_int32_t uint32;

/* Various tokens used for parsing. */
#define DBLVAL    0
#define INTVAL    1
#define BOOLVAL   2
#define DBLARG    3
#define BOOLARG   4
#define LBRACKET  5
#define RBRACKET  6
#define LPAREN    7
#define RPAREN    8
#define FUNCTION  9
#define COLON     10
#define FILEEND   11
#define AT        12
#define ERROR     13

#define DOUBLE   0
#define BOOLEAN  1

/* genetic_expression return value. */
typedef union {
  int32 i;
  double d;
} lval;


#endif
