/***********************************************************************
 *
 *   File: genetic_lexer.cc:
 *   
 *   Author: Mark Stephenson
 *   Date: Mon Aug  5 14:04:09 2002
 *
 *   Function: 
 *
 **********************************************************************/

#include "genetic_lexer.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

genetic_lexer::genetic_lexer (istream* yyin = 0, 
			      ostream* yyout = 0) :
  yyFlexLexer (yyin, yyout)
{
}

genetic_lexer::~genetic_lexer ()
{
}
  
uint32 
genetic_lexer::token ()
{
  return yylex ();
}

double 
genetic_lexer::double_val () const
{
  return atof(yytext);
}

int 
genetic_lexer::int_val () const
{
  return atoi(yytext);
}

bool
genetic_lexer::bool_val () const
{
  return (yytext[0] == 't');
}

uint32
genetic_lexer::arg_num () const
{
  return atoi(&yytext[2]);
}

char*
genetic_lexer::function_name ()
{
  strcpy (m_fname, yytext);
  return m_fname;
}

void
genetic_lexer::error (char *msg, char *sup)
{
  char emsg[80];
  
  sprintf (emsg, "%s%s", msg, sup);
  LexerError (emsg);
}
