/************************************************************************
 *
 *   File: num_string.h:
 *   
 *   Author: Mark Stephenson
 *   Date: Thu Aug 22 15:33:18 2002
 *
 *   Function: A string with a constructor that converts an integer
 *      to a string.
 *
 ************************************************************************/

#ifndef __NUM_STRING_H_
#define __NUM_STRING_H_

#include <string>
#include <stdio.h>

#define MAX_DIGITS 11   /* 32-bit machines. */

class num_string : public string
{
 public:

  num_string (int v) : string() 
  {
    char buf[MAX_DIGITS];
    sprintf (buf, "%d", v);
    this->string::operator= (string(buf));
  }

  num_string (unsigned v) : string()
  {
    char buf[MAX_DIGITS];
    sprintf (buf, "%u", v);
    this->string::operator= (string(buf));
  }
};

#endif
