/* Benchmark specification scanner. */
%{
#include "training_spec_tab.cc.h"
#include <string.h>

extern int _train_spec_lineno;
%}

space       [ \t]+
newline     \n
newbench    newbench{space}*\{
endbench    \}

alpha       [A-Za-z]
digit       [0-9] 
other       [\_\-]
var         \$({alpha}|{other}|{digit})+

semi        \;
equals      \=
comma       \,
string      \"([^\"\n]|(\\\"))*[\"]
comment     \#.*

%option noyywrap

%%

{space}       ;
{comment}     ;
{newline}     { _train_spec_lineno++; }
{newbench}    { return START; }
{endbench}    { return FINISH; }
{var}         { 
   _train_spec_lval.char_ptr_str = strdup (_train_spec_text);
   return VARIABLE; 
}
setup         { return SETUP; }
profile       { return PROFILE; }
compile       { return COMPILE; }
link          { return LINK; }
run           { return RUN; }
check         { return CHECK; }
clean         { return CLEAN; }
{semi}        { return SEMI; }
{equals}      { return EQUALS; }
{comma}       { return COMMA; }
{string}      { 
   _train_spec_lval.char_ptr_str = strdup (_train_spec_text+1); 
   if (_train_spec_lval.char_ptr_str[_train_spec_leng-2] != '"')
     fprintf (stderr, "Warning on line %d: Unterminated character string\n",
              _train_spec_lineno);
   else
     _train_spec_lval.char_ptr_str[_train_spec_leng-2] = '\0';
   return STRING;
}

%%

