import edu.mit.lcs.cag.metaopt.Finch;
import java.io.*;

public class ProxyComp
{
    public static void main(String[] args)
    {
        Finch.initializeLib();
        runCompilerAlgorithm();
        Finch.finalizeLib();
    }

    public static void runCompilerAlgorithm()
    {
        double sse = 0.0;
        
        sse += doTheWork(true);
        sse += doTheWork(false);

        try
        {
            FileOutputStream fos = new FileOutputStream("fitness");
            BufferedOutputStream bos = new BufferedOutputStream(fos);
            OutputStreamWriter osw = new OutputStreamWriter(bos);
            PrintWriter pw = new PrintWriter(osw);
            pw.println(sse);
            pw.flush();
        }
        catch (IOException e)
        {
            // Not really much we can do.
            System.err.println(e);
        }
    }
    
    private static double doTheWork(boolean b)
    {
        double sse = 0.0;

        for (double i = -10.0; i <= 10.0; i += 1.0)
            for (double j = -10.0; j <= 10.0; j += 1.0) 
            {
                // Here's the way to evaluate finch's current priority
                // function:
                double[] dbls = new double[4];
                boolean[] bools = new boolean[1];
                bools[0] = b;
                dbls[0] = i;
                dbls[1] = j;
                dbls[2] = 1.0;
                dbls[3] = 0.5;
                double val = Finch.evaluateReal(dbls, bools);
	
                // Let's see how close we get with sum of squared errors.
                double real_val = compute_function (b, i, j);
                double diff = val - real_val;
                sse += diff * diff;
            }
        
        return sse;
    }

    private static double compute_function(boolean b, double i, double j)
    {
        if (!b)
            return (i*j - j*j + 2.0);
        else
            return (i*i);
    }
}

    

